/**
 * Control.java
 *
 * File generated from the core::Control uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.hpd;

// End of user code

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;
import org.w3c.dom.Document;
import org.w3c.dom.Node;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import java.util.List;


/**
 * Description of the class Control.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "Control", propOrder = {
	"controlValue",
	"criticality",
	"type"
})
@XmlRootElement(name = "Control")
public class Control extends net.ihe.gazelle.gen.common.CommonOperations implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	@XmlElement(name = "controlValue", namespace = "urn:oasis:names:tc:DSML:2:0:core")
	public ControlValue controlValue;
	@XmlAttribute(name = "criticality")
	public Boolean criticality;
	@XmlAttribute(name = "type", required = true)
	public String type;
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private Node _xmlNodePresentation;
	
	
	/**
	 * Return controlValue.
	 * @return controlValue
	 */
	public ControlValue getControlValue() {
	    return controlValue;
	}
	
	/**
	 * Set a value to attribute controlValue.
	 * @param controlValue.
	 */
	public void setControlValue(ControlValue controlValue) {
	    this.controlValue = controlValue;
	}
	
	
	
	
	/**
	 * Return criticality.
	 * @return criticality
	 */
	public Boolean getCriticality() {
	    return criticality;
	}
	
	/**
	 * Set a value to attribute criticality.
	 * @param criticality.
	 */
	public void setCriticality(Boolean criticality) {
	    this.criticality = criticality;
	}
	
	
	/**
	 * Return criticality.
	 * @return criticality
	 * Generated for the use on jsf pages
	 */
	 @Deprecated
	public Boolean isCriticality() {
	    return criticality;
	}
	
	/**
	 * Return type.
	 * @return type
	 */
	public String getType() {
	    return type;
	}
	
	/**
	 * Set a value to attribute type.
	 * @param type.
	 */
	public void setType(String type) {
	    this.type = type;
	}
	
	
	
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.hpd");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:oasis:names:tc:DSML:2:0:core", "Control").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(Control control, String _location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (control != null){
   			cvm.validate(control, _location, diagnostic);
    	}
    }

}
